> ## Documentation Index
> Fetch the complete documentation index at: https://docs.costgraph.ai/llms.txt
> Use this file to discover all available pages before exploring further.

# Get kubernetes cluster node metrics

> Returns node-level usage and pressure time-series sourced from the metrics store, for the node fingerprint and metrics views



## OpenAPI

````yaml /api-reference/costgraph/openapi.json get /api/v1/tenant/clusters/{cluster_id}/nodes/{node_id}/metrics
openapi: 3.0.0
info:
  description: Read and manage your CostGraph organization, spend, alerts, and settings.
  title: CostGraph API
  contact: {}
  version: '1.0'
servers:
  - url: https://api.costgraph.ai
security: []
tags:
  - name: ai
    x-group: AI
  - name: ai-serving
    x-group: AI serving
  - name: anomalies
    x-group: Anomalies
  - name: auth
    x-group: Auth
  - name: billing
    x-group: Billing
  - name: billing-export
    x-group: Billing export
  - name: budgets
    x-group: Budgets
  - name: ci
    x-group: CI
  - name: compute-recommendations
    x-group: Compute recommendations
  - name: config
    x-group: Config
  - name: cost
    x-group: Cost
  - name: gpus
    x-group: GPUs
  - name: graphai
    x-group: Graph AI
  - name: infracost
    x-group: Infracost
  - name: integrations
    x-group: Integrations
  - name: invitations
    x-group: Invitations
  - name: kubernetes-clusters
    x-group: Kubernetes clusters
  - name: marketplace
    x-group: Marketplace
  - name: network-requests
    x-group: Network requests
  - name: notifications
    x-group: Notifications
  - name: oauth
    x-group: OAuth
  - name: oauth-clients
    x-group: OAuth clients
  - name: opencost
    x-group: OpenCost
  - name: organization
    x-group: Audit log
  - name: organizations
    x-group: Organizations
  - name: placement-alternatives
    x-group: Placement alternatives
  - name: reports
    x-group: Reports
  - name: service-map
    x-group: Service map
  - name: settings
    x-group: Settings
  - name: sso
    x-group: Single sign-on
  - name: tenants
    x-group: Tenants
  - name: user
    x-group: Users
  - name: virtual-machines
    x-group: Virtual machines
  - name: virtual-tags
    x-group: Virtual tags
  - name: workflows
    x-group: Workflows
paths:
  /api/v1/tenant/clusters/{cluster_id}/nodes/{node_id}/metrics:
    get:
      tags:
        - kubernetes-clusters
      summary: Get kubernetes cluster node metrics
      description: >-
        Returns node-level usage and pressure time-series sourced from the
        metrics store, for the node fingerprint and metrics views
      parameters:
        - description: Tenant ID
          name: X-CostGraph-Tenant-ID
          in: header
          required: true
          schema:
            type: string
        - description: Kubernetes cluster ID
          name: cluster_id
          in: path
          required: true
          schema:
            type: string
        - description: Kubernetes node ID
          name: node_id
          in: path
          required: true
          schema:
            type: string
        - description: Time window (e.g. 1h, 24h, 7d). Default 1h
          name: range
          in: query
          schema:
            type: string
        - description: Resolution step
          name: step
          in: query
          schema:
            type: string
        - description: >-
            Metric groups (comma-separated):
            all,system,cpu,memory,disk,network,load. Default all
          name: groups
          in: query
          schema:
            type: string
      responses:
        '200':
          description: OK
          content:
            application/json:
              schema:
                allOf:
                  - $ref: '#/components/schemas/responses.SuccessResponse'
                  - type: object
                    properties:
                      data:
                        $ref: >-
                          #/components/schemas/costgraph_agent.VirtualMachineMetrics
        '400':
          description: Bad Request
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/responses.ErrorResponse'
        '401':
          description: Unauthorized
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/responses.ErrorResponse'
        '403':
          description: Forbidden
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/responses.ErrorResponse'
        '404':
          description: Not Found
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/responses.ErrorResponse'
        '500':
          description: Internal Server Error
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/responses.ErrorResponse'
      security:
        - BearerAuth: []
components:
  schemas:
    responses.SuccessResponse:
      type: object
      required:
        - message
        - status
      properties:
        data: {}
        message:
          type: string
          example: some message
        status:
          type: string
          example: success
    costgraph_agent.VirtualMachineMetrics:
      type: object
      required:
        - end
        - start
        - step_seconds
      properties:
        cpu_irq:
          type: array
          items:
            $ref: '#/components/schemas/metrics.MetricPoint'
        cpu_nice:
          type: array
          items:
            $ref: '#/components/schemas/metrics.MetricPoint'
        cpu_psi_some:
          type: array
          items:
            $ref: '#/components/schemas/metrics.MetricPoint'
        cpu_softirq:
          type: array
          items:
            $ref: '#/components/schemas/metrics.MetricPoint'
        cpu_steal:
          type: array
          items:
            $ref: '#/components/schemas/metrics.MetricPoint'
        cpu_system:
          type: array
          items:
            $ref: '#/components/schemas/metrics.MetricPoint'
        cpu_user:
          type: array
          items:
            $ref: '#/components/schemas/metrics.MetricPoint'
        cpu_utilization:
          type: array
          items:
            $ref: '#/components/schemas/metrics.MetricPoint'
        cpu_wait:
          type: array
          items:
            $ref: '#/components/schemas/metrics.MetricPoint'
        disk_busy_percent:
          type: array
          items:
            $ref: '#/components/schemas/metrics.MetricPoint'
        disk_read_iops:
          type: array
          items:
            $ref: '#/components/schemas/metrics.MetricPoint'
        disk_read_latency:
          type: array
          items:
            $ref: '#/components/schemas/metrics.MetricPoint'
        disk_read_throughput:
          type: array
          items:
            $ref: '#/components/schemas/metrics.MetricPoint'
        disk_utilization:
          type: array
          items:
            $ref: '#/components/schemas/metrics.MetricPoint'
        disk_write_iops:
          type: array
          items:
            $ref: '#/components/schemas/metrics.MetricPoint'
        disk_write_latency:
          type: array
          items:
            $ref: '#/components/schemas/metrics.MetricPoint'
        disk_write_throughput:
          type: array
          items:
            $ref: '#/components/schemas/metrics.MetricPoint'
        end:
          type: string
        gpu_availability:
          type: object
          additionalProperties:
            type: string
        gpu_identity_source:
          type: string
        gpu_memory_used_mib:
          type: array
          items:
            $ref: '#/components/schemas/metrics.MetricPoint'
        gpu_memory_utilization:
          type: array
          items:
            $ref: '#/components/schemas/metrics.MetricPoint'
        gpu_power_utilization:
          type: array
          items:
            $ref: '#/components/schemas/metrics.MetricPoint'
        gpu_power_watts:
          type: array
          items:
            $ref: '#/components/schemas/metrics.MetricPoint'
        gpu_series:
          type: object
          additionalProperties:
            type: array
            items:
              $ref: '#/components/schemas/metrics.MetricPoint'
        gpu_units:
          type: object
          additionalProperties:
            type: string
        gpu_utilization:
          type: array
          items:
            $ref: '#/components/schemas/metrics.MetricPoint'
        io_psi_some:
          type: array
          items:
            $ref: '#/components/schemas/metrics.MetricPoint'
        load_average_15m:
          type: array
          items:
            $ref: '#/components/schemas/metrics.MetricPoint'
        load_average_1m:
          type: array
          items:
            $ref: '#/components/schemas/metrics.MetricPoint'
        load_average_5m:
          type: array
          items:
            $ref: '#/components/schemas/metrics.MetricPoint'
        memory_available:
          type: array
          items:
            $ref: '#/components/schemas/metrics.MetricPoint'
        memory_buffers:
          type: array
          items:
            $ref: '#/components/schemas/metrics.MetricPoint'
        memory_buffers_percent:
          type: array
          items:
            $ref: '#/components/schemas/metrics.MetricPoint'
        memory_cached:
          type: array
          items:
            $ref: '#/components/schemas/metrics.MetricPoint'
        memory_cached_percent:
          type: array
          items:
            $ref: '#/components/schemas/metrics.MetricPoint'
        memory_free:
          type: array
          items:
            $ref: '#/components/schemas/metrics.MetricPoint'
        memory_psi_some:
          type: array
          items:
            $ref: '#/components/schemas/metrics.MetricPoint'
        memory_used:
          type: array
          items:
            $ref: '#/components/schemas/metrics.MetricPoint'
        memory_utilization:
          type: array
          items:
            $ref: '#/components/schemas/metrics.MetricPoint'
        network_receive:
          type: array
          items:
            $ref: '#/components/schemas/metrics.MetricPoint'
        network_transmit:
          type: array
          items:
            $ref: '#/components/schemas/metrics.MetricPoint'
        start:
          type: string
        step_seconds:
          type: integer
        swap_utilization:
          type: array
          items:
            $ref: '#/components/schemas/metrics.MetricPoint'
        tcp_retransmits:
          type: array
          items:
            $ref: '#/components/schemas/metrics.MetricPoint'
    responses.ErrorResponse:
      type: object
      required:
        - message
        - status
      properties:
        message:
          type: string
          example: some message
        status:
          type: string
          example: error
    metrics.MetricPoint:
      type: object
      required:
        - t
        - v
      properties:
        t:
          type: integer
        v:
          type: number
  securitySchemes:
    BearerAuth:
      description: Enter "Bearer {token}"
      type: apiKey
      name: Authorization
      in: header

````

This documentation is built and hosted on [Mintlify](https://mintlify.com), a developer documentation platform.